#include "Paddel.h"

CPaddel::CPaddel(int side, string Modus, CBall * Ball)
{
	Timer=new CTimer();
	Paddel=new CSprite();

	this->side = side;

	if(side==1)
	{
		Paddel->Load("Data/Original/Game/Paddel1.bmp","Data/Skaliert/Game/Paddel1.bmp", 3, 50, 190);
		Pos.x=30.0f; Pos.y=500.0f;
		Paddel->SetPos(Pos.x, Pos.y);
		phase=1;
	}
	else
	{
		Paddel->Load("Data/Original/Game/Paddel2.bmp","Data/Skaliert/Game/Paddel2.bmp", 3,50,190);
		Pos.x=1840.0f; Pos.y=500.0f;
		Paddel->SetPos(Pos.x, Pos.y);
		phase=1;
	}

	Paddel->SetColorKey(255, 0, 255);

	if(Modus == "Single")
		KI_on = true;
	else
		KI_on = false;


	this->Ball = Ball;

	KI = new CKI;
}

CPaddel::~CPaddel()
{
	delete Paddel;
	delete Timer;
}

void CPaddel::Update(CBall * Ball)
{
	//Timer updaten
	Timer->Update();

	
	if(KI_on == false)
	{
		//Paddel bewegen
		if(side==1)
		{
			if(KeyDown(SDLK_s) && Pos.y<930)
			{
				Pos.y += 250 * (Timer->GetElapsed() / 1000);
				phase=2;
			}														
			else if(KeyDown(SDLK_w) && Pos.y>-35)
			{
				Pos.y -=  250 * (Timer->GetElapsed() / 1000);
				phase=0;
			}
			else
				phase= 1;
		}

		if(side==2)
		{
			if(KeyDown(SDLK_DOWN) && Pos.y<930)
			{
				Pos.y += 250 * (Timer->GetElapsed() / 1000);
				phase=0;
			}														
			else if(KeyDown(SDLK_UP) && Pos.y>-35)
			{
				Pos.y -= 250 * (Timer->GetElapsed() / 1000);
				phase=2;
			}
			else
				phase= 1;
		}
	}
	
	else					//KI ist eingeschaltet
	{

		if(side==1)			//eigenes Paddel	
		{
			if(KeyDown(SDLK_DOWN) && Pos.y<930)
			{
				Pos.y += 250 * (Timer->GetElapsed() / 1000);
				phase=2;
			}														
			else if(KeyDown(SDLK_UP) && Pos.y>-35)
			{
				Pos.y -=  250 * (Timer->GetElapsed() / 1000);
				phase=0;
			}
			else
				phase= 1;
		}


		if(side == 2)			//Paddel des Gegners
		{
			Collision = KI->GetCollision(Ball->GetPos(), Ball->GetVel());

			if(Collision == -1.0)			// Paddel in Richtung des Balls bewegen
			{		

				if(Ball->GetYPos() > Pos.y + 62  &&  Pos.y<930)
				{
					Pos.y += 250 * (Timer->GetElapsed() / 1000);
					phase=0;
				}
				else if(Ball->GetYPos() < Pos.y + 52 && Pos.y>-35)
				{
					Pos.y -= 250 * (Timer->GetElapsed() / 1000);
					phase=2;
				}
				else
					phase = 1;
			}

			else					//Paddel zum Kollisionspunkt bewegen					
			{

				if(Collision > Pos.y + 98 && Pos.y < 930)
				{
					Pos.y += 250 * (Timer->GetElapsed() / 1000);
					phase=0;
				}
				else if (Collision < Pos.y + 93 && Pos.y > -35)
				{
					Pos.y -= 250 * (Timer->GetElapsed() / 1000);
					phase=2;
				}
				else
					phase = 1;

			}	
		}
	}

}

void CPaddel::Render(SDL_Surface * screen)
{
	Paddel->SetPos(Pos.x, Pos.y);
	Paddel->Render(screen,phase);
}

bool CPaddel::KeyDown(int Key_ID)
{
	 Key=SDL_GetKeyState(NULL);
	 if(Key[Key_ID]) return true;
	 else return false;

}