#include<SDL.h>
#include"Sprite.h"
#include"Timer.h"
#include"Vector2.h"
#include<SDL_ttf.h>
#pragma once
class CBall
{
public:
	CBall();
	~CBall();
	int Update(float yPaddel1, float yPaddel2, int phase1, int phase2);
	void Render(SDL_Surface * screen);
	void Reset();
	void SetVel(int Vel);

	void Start() {isAlive = true;
					Timer->Update();};
	void Stop() {isAlive = false;};

	float GetYPos() { return Pos.y; };

	Vector2 * GetPos() { return &Pos; };
	Vector2 * GetVel() { return &Vel; };

private:
	Vector2 Pos;
	Vector2 Vel;
	int velocity;
	CSprite* Ball;
	CTimer * Timer;
	
	float lastpoint;
	float current;

	float angle;
	void ChangeAngle(float newAngle);

	bool isAlive;
};
