#pragma once
#include "Gamestate.h"
#include"Sprite.h"
#include "Paddel.h"
#include "Ball.h"
#include "Display.h"
#include "string"

class CGame :
	public CGamestate
{
public:
	CGame(string modus);
	~CGame(void);

	void handle_events(); 
    void logic();
    void render(SDL_Surface * screen);

private:
	CPaddel * Paddel1;
	CPaddel * Paddel2;
	CSprite * Background;
	CBall * Ball;
	CDisplay * Display;

	int score1;
	int score2;
	bool won;

	void Init();
};

