#include"Gamestate.h"
#include"MainMenu.h"
#include"Game.h"
#include"Options.h"
#include"Credits.h"





//nchsten Gamestate setzten
void CGamestate::set_next_state( int newState )
{
    if( Gamestate->nextState != STATE_EXIT )
    {
        Gamestate->nextState = newState;
    }
}

//Ganestate wechseln
void CGamestate::change_state()
{
    if( Gamestate->nextState != STATE_NULL )
    {
        if(Gamestate->nextState != STATE_EXIT)
        {
            delete Gamestate->currentState;
        }

        switch( Gamestate->nextState )
        {

		case STATE_MENU:
			Gamestate->currentState = new CMainMenu;
			break;
		case STATE_OPTIONS:
			Gamestate->currentState = new COptions;
			break;
		case STATE_CREDITS:
			Gamestate->currentState = new CCredits;
			break;
		case STATE_GAME_S:
			Gamestate->currentState = new CGame("Single");
			break;
		case STATE_GAME_M:
			Gamestate->currentState = new CGame("Multi");
			break;
        }

        Gamestate->stateID = Gamestate->nextState;

        Gamestate->nextState = STATE_NULL;
    }
}
