#pragma once
#ifndef  GAMESTATE_HPP
#define  GAMESTATE_HPP

#include<SDL.h>
#include"Singleton.h"

#define NULL 0 

//Game states
enum GameStates
{
    STATE_NULL,
	STATE_INTRO,
	STATE_MENU,
	STATE_OPTIONS,
	STATE_CREDITS,
	STATE_GAME_S,
	STATE_GAME_M,
    STATE_EXIT,
};

/*Classes*/
//Game state base class Abstrakt
class CGamestate
{
    public:
    virtual void handle_events() = 0;
    virtual void logic() = 0;
    virtual void render(SDL_Surface * screen) = 0;
    virtual ~CGamestate(){};

	static void set_next_state(int newState);
	static void change_state();


};

class current : public TSingleton <current>

#define Gamestate current::Get()
{
public:
int stateID;
int nextState;
CGamestate *currentState;
};

#endif