#include "KI.h"


CKI::CKI(void)
{
	//Schwierigkeitsstufe laden
	SaveLoad = new CSaveLoad;

	difficulty = SaveLoad->LoadDifficulty();
}

float CKI::GetCollision(Vector2 * BallPos, Vector2 * BallVel)
{
	BPos = *BallPos;
	BVel = *BallVel;

	switch (difficulty)
	{
	//Bei Easy beenden
	case 1:
		return -1;

		break;
	
	//Bei Medium und Hard ab bestimmter Postion Kollisionspunkt zurckgeben
	case 2:
		if(BPos.x < 1300 || BVel.x <0)
			return -1;

		else
			return CalculateColl(BPos, BVel);

		break;

	case 3:
		if(BPos.x < 1000 || BVel.x <0)
			return -1;

		else
			return CalculateColl(BPos, BVel);

		break;
	}

}

//Kollisionspunkt berechnen
float CKI::CalculateColl(Vector2 BallPos, Vector2 BallVel)
{
	while(BallPos.x < 1825)													
	{										
		BallPos.x += BallVel.x * 1/60;
		BallPos.y += BallVel.y * 1/60;
		if(BallPos.y <= 0 || BallPos.y >= 1065)
			BallVel.y *= -1;
	}

	return BallPos.y;
}