#include "MainMenu.h"


CMainMenu::CMainMenu(void)
{
	Background = new CSprite;
	Background->Load("Data/Original/Menu/Menu.bmp", "Data/Skaliert/Menu/Menu.bmp");

	Select = new CSprite;
	Select->Load("Data/Original/Menu/Menu_Select.bmp","Data/Skaliert/Menu/Menu_Select.bmp", 5,520,500);
	Select->SetColorKey(255,0,255);
	Select->SetPos(700,300);

	curSelect=1;
}


CMainMenu::~CMainMenu(void)
{
	delete Background;
	Background = NULL;

	delete Select;
	Select = NULL;
}


void CMainMenu::handle_events()
{
	SDL_Event event;
    while(SDL_PollEvent(&event))
    {
        switch(event.type)
        {
        case SDL_QUIT:
			{
			CGamestate::set_next_state(STATE_EXIT);
            break;
			}
		case SDL_KEYDOWN:
			{
				switch(event.key.keysym.sym)
				{
					case SDLK_RETURN:
						{

							//Zum aktuell ausgewhlten Menpunkt wechseln
							switch(curSelect)
							{
							case 1:
								{
									CGamestate::set_next_state(STATE_GAME_S);
									break;
								}
							case 2:
								{
									CGamestate::set_next_state(STATE_GAME_M);
									break;
								}
							case 3:
								{
									CGamestate::set_next_state(STATE_OPTIONS);
									break;
								}
							case 4:
								{
									CGamestate::set_next_state(STATE_CREDITS);
									break;
								}
							case 5:
								{
									CGamestate::set_next_state(STATE_EXIT);
									break;
								}
							}
							break;
						}
					case SDLK_DOWN:
						{
							
								curSelect++;

								if(curSelect == 6)
									curSelect=1;

							break;
						}
					case SDLK_UP:
						{
							curSelect--;

							if(curSelect == 0)
								curSelect=5;
							
							break;
						}
				}			

			}
        }
    }
}

void CMainMenu::logic()
{
}

void CMainMenu::render(SDL_Surface * screen)
{
	Background->Render(screen);
	Select->Render(screen, curSelect-1);
}