#pragma once
#include "Gamestate.h"
#include<SDL.h>
#include<Windows.h>
#include"SaveLoad.h"
#include"Sprite.h"


class COptions :
	public CGamestate
{
public:
	COptions(void);
	~COptions(void);

	void handle_events();
	void logic();
    void render(SDL_Surface * screen);

private:
	CSprite * Background;
	CSprite * Difficulty;
	CSprite * Fullscreen;
	CSprite * Select1;
	CSprite * Select2;

	CSaveLoad * SaveLoad;

	int curSelect;
	int difficulty;
	int fullscreen;

	SDL_Surface * screen;
};

