#include<math.h>

#pragma once
class Vector2
{
public:

	Vector2(){}

	Vector2(float X, float Y)
	{
		x = Y;
		y = Y;
	}


	float x;
	float y;

	// Operatoren
	//vector addieren
	void operator += (const Vector2 &rhs)
	{
		x += rhs.x;
		y += rhs.y;
	}

	//Zahl addieren
	void operator += (const float num)
	{
		float perc;		//prozent der vergrerung
		float dia;		//lnge diagonale des vektors

		dia = sqrt( (x * x) + (y * y) );
		perc= num/dia;

		x = x + x*perc;
		y= y + y*perc;
	}

	//mit Zahl multiplizieren
	void operator * (const float num)
	{
		x = x*num;
		y = y*num;
	}

	// mit vector multiplizieren
	void operator * (const Vector2 &rhs)
	{
		x *= rhs.x;
		y *= rhs.y;
	}
	//Operatoren


	//koordinaten setzen
	void setCoordinates(float X, float Y)
	{
		x=X;
		y=Y;
	}
};



