#include"Gamestate.h"
#include"Game.h"
#include"MainMenu.h"
#include"SaveLoad.h"
#include<SDL.h>




#ifdef _WIN32
#undef main
#endif

int main( int argc, char* args[] )
{
	SDL_Init (SDL_INIT_VIDEO);

	SDL_Surface * screen;

	//Objekt zum Laden/Speichern
	CSaveLoad * SaveLoad = new CSaveLoad;						
	
	
	//Laden, ob Fullscreen oder Fenstermodus																	
	bool fullscreen = SaveLoad->LoadFullscreen();

	delete SaveLoad;

	if(fullscreen == true)
	screen = SDL_SetVideoMode(1920, 1080, 32, SDL_HWSURFACE | SDL_DOUBLEBUF |SDL_FULLSCREEN);
	else
	screen = SDL_SetVideoMode(1280, 720, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);

	//Fenster benennen
	SDL_WM_SetCaption("Space-Pong", "Space-Pong");

	//anfangsstate angeben
    Gamestate->stateID = STATE_MENU;									 

	Gamestate->nextState = STATE_NULL;
	
	//anfangsstateobjekt erstellen
    Gamestate->currentState = new CMainMenu ;							 

    //Main Loop
	while(Gamestate->stateID  != STATE_EXIT )

    {
		//Events
        Gamestate->currentState->handle_events();

		//Logik
        Gamestate->currentState->logic();

		//falls ntig State ndern
        CGamestate::change_state();


		SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format,0,0,0));

		//aktuellen State rendern
        Gamestate->currentState->render(screen);

	
			if( SDL_Flip( screen ) == -1 )
			{
				return 1;
			}

	}


    return 0;
}